
def find_gcps(image, waveletLevels=3, threshold=0.5, vBlocks=5,  hBlocks=5,  maxGcps=1000):
    import ctypes
    import numpy as np
    _finder = ctypes.cdll.LoadLibrary("scikits/eartho/gcp/_finder.so")
    if not len(image.shape) == 2:
        raise Exception('In FindGcps: image must be 2D.')
    if not image.dtype == np.float32:
        raise Exception('In FindGcps: image dtype must be float32.')
    xOut = np.zeros(maxGcps,  np.int32)    
    yOut = np.zeros(maxGcps,  np.int32)    
    sOut = np.zeros(maxGcps,  np.float32)    
    _finder.FindGcps.argtypes = [ctypes.py_object,  ctypes.c_long,  ctypes.c_float,  ctypes.c_long,  ctypes.c_long, ctypes.py_object,  ctypes.py_object,  ctypes.py_object]
    _finder.FindGcps.restype = ctypes.py_object
    numGcps = _finder.FindGcps(image, waveletLevels,  threshold, vBlocks,  hBlocks,  xOut,  yOut,  sOut)
    xOut = xOut[0:numGcps]
    yOut = yOut[0:numGcps]
    sOut = sOut[0:numGcps]
    return xOut,  yOut,  sOut,  numGcps

