import osgeo.gdal as gdal
from scikits.eartho.io.partrw import *

class BandReaderWriter:
    
    def __init__(self,  dataset,  bandIndex=0):
        #try:
            if type(dataset) == str:
                dataset = gdal.Open(dataset,  gdal.GA_ReadOnly)
            self.dataset = dataset
            self.bandIndex = bandIndex
            for b in range(0,  dataset.RasterCount):
                raster = self.dataset.GetRasterBand(b+1)
                index = int(raster.GetMetadataItem("scikits.eartho.bandIndex"))
                bpart =raster.GetMetadataItem("scikits.eartho.bandPart")
                if index == bandIndex:
                    #if bpart == "SPECT":
                    #    self.spectRasterNum = b+1
                    if bpart == "XCOORD":
                        self.xCoordRasterNum = b+1
                    elif bpart == "YCOORD":
                        self.yCoordRasterNum = b+1
                    else:
                        raise Exception("Unknown band part: " + bpart)
            #if self.spectRasterNum is None or self.xCoordRasterNum is None or self.yCoordRasterNum is None:
            if self.xCoordRasterNum is None or self.yCoordRasterNum is None:
                raise Exception("Could not find all parts of band in file.") 
            #self.spectPart = PartReaderWriter(dataset,  self.spectRasterNum)
            self.xCoordPart = PartReaderWriter(dataset,  self.xCoordRasterNum)
            self.yCoordPart = PartReaderWriter(dataset,  self.yCoordRasterNum)
        #except:  
        #    raise Exception("Failed to set up BandReaderWriter.")
            
    
